# NWidgetSmallmapDisplay Class Reference

Custom container class for displaying smallmap with a vertically resizing legend panel. More...

Inheritance diagram for NWidgetSmallmapDisplay:

## Public Member Functions
virtual void | SetupSmallestSize (Window *w, bool init_array)
| Compute smallest size needed by the widget.
virtual void | AssignSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height, bool rtl)
| Assign size and position to the widget.
virtual NWidgetCore * | GetWidgetFromPos (int x, int y)
| Retrieve a widget by its position.
virtual void | Draw (const Window *w)
| Draw the widgets of the tree.
## Private Attributes
const SmallMapWindow * | smallmap_window
| Window manager instance.

## Detailed Description

Custom container class for displaying smallmap with a vertically resizing legend panel.

The legend panel has a smallest height that depends on its width. Standard containers cannot handle this case.

Note:
  The container assumes it has two childs, the first is the display, the second is the bar with legends and selection image buttons. Both childs should be both horizontally and vertically resizable and horizontally fillable. The bar should have a minimal size with a zero-size legends display. Child padding is not supported.

Definition at line 1092 of file smallmap_gui.cpp.

## Member Function Documentation

virtual void NWidgetSmallmapDisplay::SetupSmallestSize | ( | Window * | w,
|  | bool | init_array |
| ) |  |  | `[inline, virtual]`

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters:

  | w | Window owning the widget.
  | init_array | Initialize the `w->nested_array`.

Note:
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implements NWidgetBase.

Definition at line 1100 of file smallmap_gui.cpp.

References NWidgetBase::fill_x, NWidgetBase::fill_y, SmallMapWindow::GetMaxLegendHeight(), SmallMapWindow::GetMinLegendWidth(), NWidgetContainer::head, max(), min(), NWidgetBase::next, NWidgetBase::resize_x, NWidgetBase::resize_y, NWidgetBase::SetupSmallestSize(), NWidgetBase::smallest_x, NWidgetBase::smallest_y, and smallmap_window.

virtual void NWidgetSmallmapDisplay::AssignSizePosition | ( | SizingType | sizing,
|  | uint | x,
|  | uint | y,
|  | uint | given_width,
|  | uint | given_height,
|  | bool | rtl |
| ) |  |  | `[inline, virtual]`

Assign size and position to the widget.

Parameters:

  | sizing | Type of resizing to perform.
  | x | Horizontal offset of the widget relative to the left edge of the window.
  | y | Vertical offset of the widget relative to the top edge of the window.
  | given_width | Width allocated to the widget.
  | given_height | Height allocated to the widget.
  | rtl | Adapt for right-to-left languages (position contents of horizontal containers backwards).

Afterwards, pos_x and pos_y contain the top-left position of the widget, smallest_x and smallest_y contain the smallest size such that all widgets of the window are consistent, and current_x and current_y contain the current size.

Implements NWidgetBase.

Definition at line 1117 of file smallmap_gui.cpp.

References NWidgetBase::AssignSizePosition(), NWidgetBase::current_x, NWidgetBase::current_y, NWidgetContainer::head, max(), NWidgetBase::next, NWidgetBase::pos_x, NWidgetBase::pos_y, NWidgetBase::smallest_x, NWidgetBase::smallest_y, ST_RESIZE, and ST_SMALLEST.

virtual NWidgetCore* NWidgetSmallmapDisplay::GetWidgetFromPos | ( | int | x,
|  | int | y |
| ) |  |  | `[inline, virtual]`

Retrieve a widget by its position.

Parameters:

  | x | Horizontal position relative to the left edge of the window.
  | y | Vertical position relative to the top edge of the window.

Returns:
  Returns the deepest nested widget that covers the given position, or `NULL` if no widget can be found.

Implements NWidgetBase.

Definition at line 1141 of file smallmap_gui.cpp.

References NWidgetBase::current_x, NWidgetBase::current_y, NWidgetCore::GetWidgetFromPos(), NWidgetContainer::head, IsInsideBS(), NWidgetBase::next, NWidgetBase::pos_x, and NWidgetBase::pos_y.

virtual void NWidgetSmallmapDisplay::Draw | ( | const Window * | w | ) | `[inline, virtual]`

Draw the widgets of the tree.

The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters:

  | w | Window that owns the tree.

Implements NWidgetBase.

Definition at line 1151 of file smallmap_gui.cpp.

References NWidgetContainer::head, and NWidgetBase::next.

The documentation for this class was generated from the following file:

- src/smallmap_gui.cpp